/*
 *   Copyright (C) 2007 Tobias Koenig <tokoe@kde.org>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

/*
 * Baed on Marco Mentasti's code for "Supporto Buongiorno"
 */

var findNewDate = new Boolean();
const mainPage = "http://www.shockdom.com/webcomics/drizzit/";

function init()
{
    comic.comicAuthor = "Bigio";   
    comic.shopUrl = "http://www.shockdom.com/webcomics/drizzit/";
    comic.firstIdentifier = "2012-03-24";
    
    var today = date.currentDate();

  var url = mainPage + comic.identifier.toString("yyyy/MM/dd/");

  var infos = {
    "User-Agent": "Mozilla/5.0 (compatible; Konqueror/4.4; Linux) KHTML/4.4.2 (like Gecko)",
    "Accept": "text/html, image/jpeg, image/png, text/*, image/*, */*",
    "Accept-Encoding": "functionlate",
    "Accept-Charset": "iso-8859-1, utf-8;q=0.5, *;q=0.5",
    "Host": "shockdom.com",
    "Connection": "Keep-Alive"
  }

  comic.requestPage(url, comic.User, infos);
}

function pageRetrieved(id, data)
{
  if (id == comic.User)
  {
    re = new RegExp("<h2 class=\"posttitle\"><a href=\"(" + mainPage + "(\\d{4}/\\d{2}/\\d{2}/)[^\"]+)\" rel=\"bookmark\" title=\"[^\"]+\">[^\"]+</a></h2>");
    match = re.exec(data);
    if (match != null) {
      if (findNewDate == true) {
        comic.lastIdentifier = date.fromString(match[2], "yyyy/MM/dd/");
        findNewDate = false;
      }
      comic.requestPage(match[1], comic.Page);
    }
    else {
      findNewDate = true;
      comic.websiteUrl = mainPage;
      comic.requestPage(mainPage, comic.User);
    }
  }

  if (id == comic.Page) {
    comic.websiteUrl = mainPage + comic.identifier.toString("yyyy/MM/dd") + "/";

    // grab image (avoid whitespaces between tags, search url between single or double quote)
    var re = new RegExp("<div class=\"entry\">[^\d]*<p[^\>]*><a href=[\"\']([^\"\']+)[\"\']>");
    var match = re.exec(data);
    if (match != null) {
      comic.requestPage(match[1], comic.Image);
    } else {
      comic.error();
      return;
    }

    // grab image title
    re = new RegExp("<h2 class=\"posttitle\">([^\"]+)</h2>");
    match = re.exec(data);
    if (match != null) {
      comic.title = match[1];
    }

    // grab previous identifier from header
    re = new RegExp("<link rel='prev' title=\'[^\']+\' href=\'" + mainPage + "(\\d{4}/\\d{2}/\\d{2}/)[^\"]+>");
    match = re.exec(data);
    if (match != null) {
      comic.previousIdentifier = date.fromString(match[1], "yyyy/MM/dd/");
    }

    // grab next identifier from header
    re = new RegExp("<link rel='next' title=\'[^\']+\' href=\'" + mainPage + "(\\d{4}/\\d{2}/\\d{2}/)[^\"]+>");
    match = re.exec(data);
    if (match != null) {
      comic.nextIdentifier = date.fromString(match[1], "yyyy/MM/dd/");
    }
  }
}
