/********************************************************************************
 *	Copyright (C) 2009 Marlon Rodriguez					*
 *										*
 *	This program is free software; you can redistribute it and/or modify	*
 *	it under the terms of the GNU General Public License as published by	*
 *	the Free Software Foundation; either version 2 of the License, or	*
 *	(at your option) any later version.					*
 *										*
 *	This program is distributed in the hope that it will be useful,		*
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of		*
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the		*
 *	GNU General Public License for more details.				*
 *										*
 *	You should have received a copy of the GNU General Public License	*
 *	along with this program; if not, write to the				*
 *	Free Software Foundation, Inc.,						*
 *	51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA.		*
 *										*
 *	Author: Marlon Rodriguez	Date:08/05/2009		v1.3		*
 *	Largely based on the samples at:					*
 *	http://techbase.kde.org/Development/Tutorials/Plasma/ComicPlugin	*
 ********************************************************************************/

function init()
{
    comic.comicAuthor = "Ryan Sohmer and Lar DeSouza";
    comic.firstIdentifier = "2003-02-10";
    comic.shopUrl = "https://secure.leasticoulddo.com/store/";
	comic.websiteUrl = "http://www.leasticoulddo.com/"
	
    var today = date.currentDate();
 
	if ( comic.identifier.date >= today.date ) { //getting the latest comic
		//print("Getting Today's comic: " + comic.identifier);
		comic.requestPage( comic.websiteUrl, comic.User);
	} else {
		//print( "Getting: " + comic.websiteUrl + "comic/" + comic.identifier.toString( "yyyyMMdd") + "/");
		comic.requestPage( comic.websiteUrl + "comic/" + comic.identifier.toString( "yyyyMMdd") + "/", comic.Page);
	}
}

function decodeHTML_Entity(str)
{
	//Change html entities with their numeric equivalent...
	str = str.replace(/&quot;/g, '"');
	str = str.replace(/&apos;/g, "'");
	str = str.replace(/&amp;/g, "&");
	str = str.replace(/&lt;/g, "<");
	str = str.replace(/&gt;/g, ">");
	str = str.replace(/&nbsp;/g, " ");
	str = str.replace(/&raquo;/g, "&#187;");
	str = str.replace(/&raquo/g, "&#187;");
	
	//replace all HTML numeric entities with the Charcode
	//came up with this method looking at:
	// http://bytes.com/topic/javascript/answers/152866-decoding-numeric-html-entities
	str = str.replace( /&#(\d+);/g,function(wholematch, match1){return String.fromCharCode(match1);});
	return str;
}

function pageRetrieved(id, data)
{
	if (id == comic.User) { //handle getting the latest comic from the main website.
		var re = new RegExp(' href="([^"]+)" id="feature-comic"');
		var match = re.exec(data);
		if (match != null) {
			//print("Requesting: " + match[1]);
			comic.requestPage(match[1], comic.Page);
        } else {
			comic.error();
        }
	}
	if (id == comic.Page) {
		var re = new RegExp(' id="comic-img".+src="([^"]+)"');
        var match = re.exec(data);
        if (match != null) {
			comic.additionalText = comic.identifier.toString("yyyyMMdd");
			comic.title = comic.identifier.toString("yyyyMMdd");
			//print("Requesting: " + match[1]);
			//print("-------- Current: " + comic.identifier.toString("yyyyMMdd"));
			comic.requestPage(match[1], comic.Image);
        } else {
            comic.error();
        }

		//Previous
		re = new RegExp(/(\d{8})[^"]?" id="nav-large-prev/);
        match = re.exec(data);
        if (match != null) {
			//print("-------- Prev: " + match[1]);
            comic.previousIdentifier = date.fromString(match[1], "yyyyMMdd");
        } else {
			//comic.previousIdentifier = date.fromString((parseInt(comic.identifier.toString( "yyyyMMdd")) - 1).toString(), "yyyyMMdd");
			//comic.previousIdentifier = comic.identifier.addDays(-1);
			print("-------- Prev: " + comic.previousIdentifier.toString( "yyyyMMdd"));
		}

		//Next
		re = new RegExp(/(\d{8})[^"]+" id="nav-large-next/);
        match = re.exec(data);
		if (match != null) {
			//print("-------- Next: " + match[1]);
            comic.nextIdentifier = date.fromString(match[1], "yyyyMMdd");
		} else {
			//comic.nextIdentifier = date.fromString((parseInt(comic.identifier.toString( "yyyyMMdd")) + 1).toString(), "yyyyMMdd");
			comic.nextIdentifier = comic.identifier.addDays(1);
			//print("-------- Next: " + comic.nextIdentifier.toString( "yyyyMMdd"));
		}
    }
}