/*
 *   Copyright (C) 2009 Mathias Panzenböck <grosser.meister.morti@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

const comicPrefix = 'http://ableandbaker.net/index.php?comic=';

function init() {
	comic.comicAuthor     = "Jim Burgess";
	comic.shopUrl         = "http://ableandbaker.net/merchandise/";
	comic.firstIdentifier = 1;
	
	if (!comic.identifierSpecified) {
		comic.requestPage("http://ableandbaker.net/", comic.User);
	}
	else {
		comic.requestPage(comicPrefix + comic.identifier, comic.Page);
	}
}

function pageRetrieved(id, data) {
	if (id == comic.Image) {
		return;
	}

	// find the most recent strip
	var re = /<img src="(comics\/able(\d+)\.\w+)">/;
	var match = re.exec(data);
	if (match == null) {
		print('*** could not parse image for comic ' + comic.identifier);
		comic.error();
		return;
	}
	
	if (!comic.identifierSpecified) {
		comic.identifier = match[2];
	}

	if (id == comic.User) {
		comic.lastIdentifier = match[2];
	}

	comic.requestPage('http://ableandbaker.net/' + match[1], comic.Image);

	comic.websiteUrl = comicPrefix + comic.identifier;
		
	// find the strip title
	re = /<div class="column">Comic #\d+ - ([^<]*)<\/div>/;
	match = re.exec(data);
	if (match != null) {
		comic.title = match[1];
	}

	// find today's fact
	re = /(<p><strong>Today's fact:<\/strong>[^<]*<\/p>)/;
	match = re.exec(data);
	if (match != null) {
		comic.additionalText = match[1];
	}

	// find previous link
	re = /<div class="previous"><a href="\/index\.php\?comic=(\d+)">/;
	match = re.exec(data);
	if (match != null) {
		comic.previousIdentifier = match[1];
	}

	// find next link
	re = /<div class="next"><a href="\/index\.php\?comic=(\d+)">/;
	match = re.exec(data);
	if (match != null) {
		comic.nextIdentifier = match[1];
	}
	else {
		comic.lastIdentifier = comic.identifier;
	}
}
