/*
 *   Copyright (C) 2009 Todd
 *
 *   Based on the XKCD comic engine by Tobias Koenig <tokoe@kde.org>
 *   and Matthias Fuchs <mat69@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

function init()
{
    comic.websiteUrl = "http://abstrusegoose.com/";

    comic.requestPage(comic.websiteUrl, comic.User);
}

function pageRetrieved(id, data)
{
    //find the most recent strip
    var re
    var match
    if (id == comic.User) {
        re = new RegExp("<h3 class=\"storytitle\"><a href=\"http://abstrusegoose\\.com/(\\d+)\" rel=\"bookmark\">");
        match = re.exec(data);
        if ( match != null ) {
            comic.lastIdentifier = match[1];
            comic.websiteUrl += comic.identifier;
            comic.requestPage(comic.websiteUrl, comic.Page);
        } else {
            comic.error();
        }
    }
    if (id == comic.Page) {
        re = new RegExp("src=\"(?:http://abstrusegoose\.com)?(?:/)?(strips/[^\"]+)\"");
        match = re.exec(data);
        if (match != null) {
            comic.requestPage("http://abstrusegoose.com/" + match[1], comic.Image);
        } else {        
            comic.error();
            return;
        }

        //find the tooltip and the strip title of the comic
        re = new RegExp("<h3 class=\"storytitle\"><a href=\"http://abstrusegoose.com/\\d+\" rel=\"bookmark\">([^<]+)</a></h3>");
        match = re.exec(data);
        if (match != null) {
            comic.title = match[1];
        }
        re = new RegExp("<div class=\"storycontent\">\\s+(?:<p>[^<]+</p>\\s+)?<p>(?:<a href=[^>]+>)?<img [^>]+ title=\"([^\"]+)\"");
        match = re.exec(data);
        if (match != null) {
            comic.additionalText = match[1];
        } else {
            re = new RegExp("<div class=\"storycontent\">\\s+(?:<p>[^<]+</p>\\s+)?<p>(?:<a href=[^>]+>)?<img[^>]+alt=\"([^\"]+)\"");
            match = re.exec(data);
            if (match != null) {
                comic.additionalText = match[1];
            } 
        }
    }
}
