/*
 *   Copyright (C) 2009 Mathias Panzenböck <grosser.meister.morti@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

const mainPage    = "http://www.awkwardzombie.com/comic1.php";
const comicPrefix = "http://www.awkwardzombie.com/comic1-";

function init() {
	comic.comicAuthor     = "Katharine Chandler Tiedrich XIV";
	comic.firstIdentifier = "092006";
	comic.websiteUrl	  = mainPage;

	if (comic.identifier == '') {
		comic.requestPage('http://www.awkwardzombie.com/index.php', comic.User);
	}
	else {
		comic.websiteUrl = comicPrefix + comic.identifier + '.php';
		comic.requestPage(comic.websiteUrl, comic.Page);
	}
}

function pageRetrieved(id, data) {
	// find the most recent comic
	if (id == comic.User) {
		var re = /<a href="http:\/\/www.awkwardzombie.com\/comic1-([^\.]*)\.php">\n<img src="http:\/\/www.awkwardzombie.com\/newsnav1-1\.gif"/;
		var match = re.exec(data);
		if (match != null) {
			comic.lastIdentifier = match[1];
			comic.identifier = comic.lastIdentifier;
			comic.websiteUrl = comicPrefix + comic.identifier + '.php';
			comic.requestPage(comic.websiteUrl, comic.Page);
		}
		else {
			comic.error();
		}
	}
	// get the comic image and all other available information
	else if (id == comic.Page) {
		// get the title
		var re = /<p><center>([^<]*)<\/center>/;
		var match = re.exec(data);
		if (match != null) {
			comic.title = match[1];
		}

		// getting the description
		var i = data.search('<p><font size="1"><u><b>');
		if (i != -1) {
			var descr = data.substring(i);
			i = descr.search('</td>');
			if (i != -1) {
				descr = descr.substring(0, i);
			}
			comic.additionalText = descr;
		}

		// getting the image
		re = /<p><img src="([^"]*)">/;
		match = re.exec(data);
		if (match != null) {
			comic.requestPage(match[1], comic.Image);
		} else {
			comic.error();
			return;
		}
 
 		// getting the previous identifier
		re = /<a href="http:\/\/www.awkwardzombie.com\/comic1-([^\.]*)\.php">\n<img border="0" src="http:\/\/www.awkwardzombie.com\/comnav1_2\.gif"><\/a>/;
		match = re.exec(data);
		if (match != null) {
			comic.previousIdentifier = match[1];
		}
 
 		// getting the next identifier
		re = /<a href="http:\/\/www.awkwardzombie.com\/comic1-([^\.]*)\.php">\n<img border="0" src="http:\/\/www.awkwardzombie.com\/comnav1_4\.gif"><\/a>/;
		match = re.exec(data);
		if (match != null) {
			comic.nextIdentifier = match[1];
		}
	}
}
