/***************************************************************************
 *   Copyright (C) 2009 Matthias Fuchs <mat69@gmx.net>                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

var getQuote = false;

function init()
{
    comic.firstIdentifier = "2007-08-01";
    comic.websiteUrl = "http://bash.org.ru/comics/";
    comic.textCodec = "Windows-1251";

    if ( comic.identifier.date >= comic.lastIdentifier.date ) {
        comic.requestPage( comic.websiteUrl, comic.User );
    }
    else {
        comic.websiteUrl += comic.identifier.toString( "yyyyMMdd" );
        comic.requestPage( comic.websiteUrl, comic.Page );
    }
}

function pageRetrieved(id, data)
{
    //find the most recent comic
    if ( id == comic.User ) {
        if ( !getQuote ) {
            const expLast = new RegExp( "<td class=\"active\"><a href=\"/comics/(\\d{8})\">" );
            const matchLast = expLast.exec( data );
            if ( matchLast != null ) {
                comic.lastIdentifier = date.fromString( matchLast[1], "yyyyMMdd" );
                comic.websiteUrl += comic.identifier.toString( "yyyyMMdd" );
                comic.requestPage( comic.websiteUrl, comic.Page );
            } else {
                comic.error();
            }
        } else {
            var dataString = data.toString();
            var text = "<div>";
            var indexStart = dataString.indexOf( "/comics/" );
            indexStart = dataString.indexOf( text, indexStart ) + text.length
            var indexEnd = dataString.indexOf( "</div>", indexStart );
            if ( ( indexStart > -1 ) && ( indexEnd > -1 ) ) {
                comic.additionalText = dataString.substring( indexStart, indexEnd );
            }
        }
    }
    if ( id == comic.Page ) {
        const expTitle = new RegExp( "<div style=\"float: left;\">([^<]+)<a href=\"/quote/(\\d+)\">([^<]+)</a>" );
        const matchTitle = expTitle.exec( data );
        if ( matchTitle != null ) {
            comic.title = matchTitle[1] + " " + matchTitle[3];
            var url = "http://bash.org.ru/quote/" + matchTitle[2];
            getQuote = true;
            comic.requestPage( url, comic.User );
        }

        const expComic = new RegExp( "<img src=\"(http://s.bash.org.ru/img/[^\"]+)\" id=\"cm_strip\"" );
        const matchComic = expComic.exec( data );
        if ( matchComic != null ) {
            var url = matchComic[1];
            comic.requestPage( url, comic.Image );
        } else {
            comic.error();
        }

        const expAuthor = new RegExp( "<div style=\"float: right; text-align: right;\">[^,]+, (<a href=\"[^\"]+\">)*([^<]+)<" );
        const matchAuthor = expAuthor.exec( data );
        if ( matchAuthor != null ) {
            comic.comicAuthor = matchAuthor[2];
        }

        const expPrev = new RegExp( "<a href=\"/comics/(\\d{8})\">&larr;" );
        const matchPrev = expPrev.exec( data );
        if ( matchPrev != null ) {
            comic.previousIdentifier = date.fromString( matchPrev[1], "yyyyMMdd" );
        }

        const expNext = new RegExp( "<a href=\"/comics/(\\d{8})\">&rarr;" );
        const matchNext = expNext.exec( data );
        if ( matchNext != null ) {
            comic.nextIdentifier = date.fromString( matchNext[1], "yyyyMMdd" );
        }
    }
}
