/***************************************************************************
 *   Copyright (C) 2008 Matthias Fuchs <mat69@gmx.net>                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

function init()
{
    comic.comicAuthor = "Jay Naylor";
    comic.firstIdentifier = "2003/04/post-2"
    comic.websiteUrl = "http://www.jaynaylor.com/betterdays/";

    if ( comic.identifier.length ) {
        comic.websiteUrl += "archives/" + comic.identifier + ".html";
        comic.requestPage( comic.websiteUrl, comic.Page );
    } else {
       comic.requestPage( comic.websiteUrl, comic.User );
    }
}

function pageRetrieved(id, data)
{
    //find the most recent comic
    if ( id == comic.User ) {
        const expLast = new RegExp( "http://www.jaynaylor.com/betterdays/archives/(\\d{4}/\\d{2}/[^.]+).html#comments" );
        const matchLast = expLast.exec( data );
        if ( matchLast != null ) {
            comic.lastIdentifier = matchLast[1];
            comic.identifier = comic.lastIdentifier;
            comic.websiteUrl += "archives/" + comic.identifier + ".html";
            comic.requestPage( comic.websiteUrl, comic.Page );
        } else {
            comic.error();
        }
    }
    if ( id == comic.Page ) {
        const expComic = new RegExp( "<img src=/betterdays/comic/([^>]+)>" );
        const matchComic = expComic.exec( data );
        if ( matchComic != null ) {
            var url = "http://www.jaynaylor.com/betterdays/comic/" + matchComic[1];
            comic.requestPage( url, comic.Image );
        } else {
            comic.error();
        }

        const expPrev = new RegExp( "rel=\"prev\" href=\"http://www.jaynaylor.com/betterdays/archives/(\\d{4}/\\d{2}/[^.]+).html" );
        const matchPrev = expPrev.exec( data );
        if ( matchPrev != null ) {
            comic.previousIdentifier = matchPrev[1];
        }

        const expNext = new RegExp( "rel=\"next\" href=\"http://www.jaynaylor.com/betterdays/archives/(\\d{4}/\\d{2}/[^.]+).html" );
        const matchNext = expNext.exec( data );
        if ( matchNext != null ) {
            comic.nextIdentifier = matchNext[1];
        }

        const expChapter = new RegExp( "<title>Better Days: ([^<]+)</title>" );
        const matchChapter = expChapter.exec( data );
        if ( matchChapter != null ) {
            comic.title = matchChapter[1];
        }
    }
}
