/*
 *   Copyright (C) 2009 Todd
 *
 *   Based on the XKCD comic engine by Tobias Koenig <tokoe@kde.org>
 *   and Matthias Fuchs <mat69@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

var firstImage = 0;
var urlArray = new Array();

function init()
{
    comic.comicAuthor = "Jay Dee";
    comic.websiteUrl = "http://www.captainsnes.com/";
    comic.firstIdentifier = "2001/07/10/the-mistake/";
  
    if (comic.identifier == 0) {
        comic.requestPage(comic.websiteUrl, comic.User);
    } else {
        comic.websiteUrl += comic.identifier;
        comic.requestPage(comic.websiteUrl, comic.Page);
    }

}

function pageRetrieved(id, data)
{
    var re;
    var match;
    var appended="";

    //find the most recent strip
    if (id == comic.User) {
        re = new RegExp("<a href=\"(http://www.captainsnes.com/(\\d+/\\d+/\\d+/[\\w-]+/))\" rel=\"bookmark\" title=\"Permanent Link");
        match = re.exec(data);

        if ( match != null ) {
            comic.lastIdentifier = match[2];
            comic.websiteUrl = match[1];
            comic.requestPage(comic.websiteUrl, comic.Page);
        } else {
            comic.error();
            return;
        }
    }

    //find the target strip
    if (id == comic.Page) {
        re = new RegExp("(http://www.captainsnes.com/comics/[\\w-]+\\.\\w+)","g");
        match = data.match(re);
        if (match != null && match != "") {
            urlArray=match;
        } else {
            urlArray.push("http://www.captainsnes.com/images/title.gif");
            appended="Comic Not Found: "
        }

 
        //download the last url in the array
        comic.requestPage(urlArray.pop(), comic.Image);

        re = new RegExp("<a href=\"http://www.captainsnes.com/(\\d+/\\d+/\\d+/[\\w-]+/)\">\\&\\#9668; Previous</a>");
        match = re.exec(data);
        if (match != null) {
            comic.previousIdentifier = match[1];
        }

        re = new RegExp("<a href=\"http://www.captainsnes.com/(\\d+/\\d+/\\d+/[\\w-]+/)\">Next \\&\\#9658;</a>");
        match = re.exec(data);
        if (match != null) {
            comic.nextIdentifier = match[1];
        }

        re = new RegExp("rel=\"bookmark\" title=\"Permanent Link:\\s*([^\"]+)\">");
        match = re.exec(data);
        if (match != null) {
            comic.title = appended + match[1];
        }
    }
    if (id == comic.Image) {
        if (firstImage != 0) {
            comic.combine(firstImage, comic.Bottom);
        }

        if (urlArray.length > 0) {
            firstImage = comic.image();
            comic.requestPage(urlArray.pop(), comic.Image);
        }
    }
}
