/*
 *   Les Céréales du Dimanche Matin plugin for comic plasma widget
 *   Copyright (C) 2011 Mathieu Guilbaud <mathieu@guim.info>
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

const imgSrc = "http://cereales.lapin.org/";

function init() {
	comic.comicAuthor = "Zack Weiner";
	comic.firstIdentifier = "1";
	comic.websiteUrl = "http://cereales.lapin.org/index.php";
	comic.shopUrl = "http://cereales.lapin.org/";
	
	if ( comic.identifierSpecified ) {
		comic.requestPage(comic.websiteUrl+"?number="+comic.identifier, comic.Page);
	} else {
		// find current
		comic.requestPage(comic.websiteUrl, comic.Page);
	}
}

function pageRetrieved(id, data) {
	if (id == comic.Page) {
		var re = new RegExp("<h2 class=\"episode\">(\\d+)[^<]*</h2>");
		var match = re.exec(data);
		if (match != null) {
			var value = match[1];
			// current (last one)
			if (! comic.identifierSpecified) {
				comic.identifier = value;
				comic.lastIdentifier = value;
				comic.previousIdentifier = value-1;
			}
			// everything else
			else {
				comic.identifier = value;
				comic.nextIdentifier = parseInt(value)+1;
				if (comic.firstIdentifier < comic.identifier) {
					comic.previousIdentifier = value-1;
				}
			}
			re = new RegExp("<div align=\"right\"> .*<img style='border:0;' width=\"\\d+\" height=\"\\d+\" alt=\"([^\"]+)\" title=\"[^\"]+\" src=\"([^\"]+)\" /><br />", "m");
			match = re.exec(data);
			if (match != null) {
				comic.title = match[1];
				comic.additionalText = match[1];
				url = imgSrc + match[2];
				comic.requestPage(url, comic.Image);
			} else {
				comic.error();
			}
		}
		else {
			comic.error();
		}
	}
}