/*
 *   Copyright (C) 2009 Mathias Panzenböck <grosser.meister.morti@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

const GetLast     = comic.User;
const mainPage    = 'http://www.drunkduck.com/Culture_Shock/';
const comicPrefix = 'http://www.drunkduck.com/Culture_Shock/index.php?p=';

function init() {
	comic.comicAuthor     = 'Reed Hawker';
	comic.firstIdentifier = '33';
	comic.shopUrl         = 'http://www.drunkduck.com/store.php';
	
	if (comic.identifierSpecified) {
		comic.requestPage(comicPrefix + comic.identifier, comic.Page);
	}
	else {
		comic.requestPage(mainPage, GetLast);
	}
}

function pageRetrieved(id, data) {
	if (id == comic.Image) {
		return;
	}

	var comicId, re, match;

	// find the most recent strip
	if (id == GetLast) {
		re = /'\/xmlhttp\/addBookmark\.php\?cid=\d+&p=(\d+)'/;
		match = re.exec(data);
		if (match != null) {
			comic.lastIdentifier = comic.identifier = comicId = match[1];
		}
		else {
			print('*** error parsing last comic');
			comic.error();
			return;
		}
	}
	else {
		comicId = comic.identifier;
	}

	comic.websiteUrl = comicPrefix + comicId;
	
	// find image
	re = /<IMG SRC='(http:\/\/comics\.drunkduck\.com\/Culture_Shock\/pages\/[^']*)'>/;
	match = re.exec(data);
	if (match != null) {
		comic.requestPage(match[1], comic.Image);
	}
	else {
		print('*** error parsing image location');
		comic.error();
		return;
	}

	// find title
	re = /<OPTION *VALUE='\d+' SELECTED>([^<]*)<\/OPTION>/;
	match = re.exec(data);
	if (match != null) {
		comic.title = match[1];
	}
	
	// find previous link
	re = /<A HREF='\/Culture_Shock\/index\.php\?p=([^']*)' TITLE='The previous page!'>/;
	match = re.exec(data);
	if (match != null) {
		comic.previousIdentifier = match[1];
	}
	
	// find next link
	re = /<A HREF='\/Culture_Shock\/index\.php\?p=([^']*)' TITLE='The next page!'>/;
	match = re.exec(data);
	if (match != null) {
		comic.nextIdentifier = match[1];
	}
}
