/***************************************************************************
 *   Copyright (C) 2018 Matthias Fuchs <mat69@gmx.net>                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

function init()
{
    comic.comicAuthor = "Jeffrey T. Darlington";
    comic.firstIdentifier = "1998-11-02";
    comic.websiteUrl = "https://www.gpf-comics.com/";
    comic.websiteShop = "https://www.gpf-comics.com/store/home.php";

    comic.requestPage( comic.websiteUrl, comic.User );
}

function pageRetrieved( id, data )
{
    //find last strip
    if (id == comic.User) {
        var exp = new RegExp("addthis:url=\"https://www.gpf-comics.com/archive/(\\d{4}/\\d{2}/\\d{2})");
        var match = exp.exec(data);
        if (match != null) {
            comic.lastIdentifier = date.fromString(match[1], "yyyy/MM/dd");
            comic.websiteUrl += "archive/" + comic.identifier.toString("yyyy/MM/dd");
            comic.requestPage(comic.websiteUrl, comic.Page);
        } else {
            print("Failed finding last strip.");
            comic.error();
        }
    }
    if ( id == comic.Page ) {
        const expPrev = new RegExp('<link rel="prev" href="[^"]+(\\d{4}/\\d{2}/\\d{2})');
        const matchPrev = expPrev.exec( data );
        if ( matchPrev != null ) {
            comic.previousIdentifier = date.fromString( matchPrev[1], "yyyy/MM/dd" );
        }

        const expNext = new RegExp('<link rel="next" href="[^"]+(\\d{4}/\\d{2}/\\d{2})');
        const matchNext = expNext.exec( data );
        if ( matchNext != null ) {
            comic.nextIdentifier = date.fromString( matchNext[1], "yyyy/MM/dd" );
        }

        const expImgage = new RegExp( "p><img src=\"/comics/([^\"]+)\"" );
        const matchImage = expImgage.exec( data );
        if ( matchImage != null ) {
            var url = "https://www.gpf-comics.com/comics/" + matchImage[1];
            comic.requestPage( url, comic.Image );
        } else {
            print("Failed finding image.");
            comic.error();
        }

    }
}

