/*
 *   Copyright (C) 2011 Riaas Mokiem <arucard21@gmail.com>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

function init()
{
	comic.comicAuthor = "Danielle Corsetto";
	comic.websiteUrl = "https://girlswithslingshots.com/";
	comic.shopUrl = "https://shop.blindferret.com/GWS";
	//check if a specific comic was requested
	if(comic.identifierSpecified){
		//get that specific comic, through its identifier
		comic.requestPage(comic.websiteUrl+comic.identifier, comic.Page);
	}
	else{		
		//get the most recent comic
		comic.requestPage(comic.websiteUrl, comic.Page);
	}
}

function pageRetrieved(id, data)
{
	//parses the comic page to find the available identifiers 
	if (id == comic.Page) {
		//set the first comic's identifier
		var firstComicRegEx = new RegExp("<a class=\"cc-first\" rel=\"first\" href=\"(?:http:|https:)?//(?:www\.)?girlswithslingshots.com/(comic/gws1)\"");
		var firstComic = firstComicRegEx.exec(data);
		if(firstComic != null){
			comic.firstIdentifier = firstComic[1];
		}
		//set the previous comic's identifier
		var prevComicRegEx = new RegExp("<a class=\"cc-prev\" rel=\"prev\" href=\"(?:http:|https:)?//(?:www\.)?girlswithslingshots.com/([^\"]*)\"");
		var prevComic = prevComicRegEx.exec(data);
		if(prevComic != null){
			comic.previousIdentifier = prevComic[1];
		}
		//set the next comic's identifier
		var nextComicRegEx = new RegExp("<a class=\"cc-next\" rel=\"next\" href=\"(?:http:|https:)?//(?:www\.)?girlswithslingshots.com/([^\"]*)\"");
		var nextComic = nextComicRegEx.exec(data);
		if(nextComic != null){
			comic.nextIdentifier = nextComic[1];
		}
		//set the last comic's identifier
		var lastComicRegEx = new RegExp("<a class=\"cc-last\" rel=\"last\" href=\"(?:http:|https:)?//(?:www\.)?girlswithslingshots.com/([^\"]*)\"");
		var lastComic = nextComicRegEx.exec(data);
		if(lastComic != null){
			comic.lastIdentifier = lastComic[1];
		}
		//get the image and additional text for the comic on this page
		var curComicRegEx = new RegExp("<img title=\"([^\"]*)\" src=\"(?:http:|https:)?//(?:www\.)?girlswithslingshots.com/([^\"]*)\" id=\"cc-comic\"");
		var curComic = curComicRegEx.exec(data);
		if ( curComic == null ) {
			// return an error if no comic image was found
			comic.error();
			print("The requested comic image can not be found on the comic page")
			return;
		}
		//set the current comic and its attributes
		comic.additionalText = curComic[1];
		var comicTitleRegEx = new RegExp("<title>Girls With Slingshots - (.*)</title>");
		var comicTitle = comicTitleRegEx.exec(data);
		if (comicTitle != null){
			comic.title = comicTitle[1];
		}
		comic.requestPage(comic.websiteUrl+curComic[2], comic.Image);
	}
}
