/***************************************************************************
 *   Copyright (C) 2008 Matthias Fuchs <mat69@gmx.net>                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

var findNewDate = new Boolean();
const mainPage = "http://goodtimescomics.com/";

function init()
{
    comic.comicAuthor = "Sam Beatty";
    comic.firstIdentifier = "2007-04-23";

    var today = date.currentDate();
    findNewDate = ( comic.identifier.date >= today.date );
    var url = mainPage;

    if ( !findNewDate ) {
        url += comic.identifier.toString( "yyyy/MM/dd/" );
    }

    comic.requestPage( url, comic.User );
}

function pageRetrieved(id, data)
{
    //find the url to the comic website
    if ( id == comic.User ) {
        if ( findNewDate ) {
            const expDate = new RegExp( "<img src=\"" + mainPage + "comics/(\\d{4}-\\d{2}-\\d{2})" );
            const matchDate = expDate.exec ( data );
            if ( matchDate != null ) {
                comic.identifier = date.fromString( matchDate[1], date.ISODate );
                var url = mainPage + comic.identifier.toString( "yyyy/MM/dd/" );
                findNewDate = false;
                comic.requestPage( url, comic.User );
            } else {
                comic.error();
            }
        } else {
            const expUrl = new RegExp( "<a href=\"(" + mainPage + comic.identifier.toString( "yyyy/MM/dd/" ) + "[^\"]+)\"><img" );
            const matchUrl = expUrl.exec( data );
            if ( matchUrl != null ) {
                comic.websiteUrl = matchUrl[1];
                comic.requestPage( comic.websiteUrl, comic.Page );
            } else {
                comic.error();
            }
        }
    }
    if ( id == comic.Page ) {
        var url = mainPage + "comics/";
        const expImage = new RegExp( "<img src=\"(" + url + comic.identifier.toString( date.ISODate ) + "[^\"]+)\" alt=\"([^\"]+)\"" );
        const matchImage = expImage.exec( data );
        if ( matchImage != null ) {
            url = matchImage[1];
            comic.title = matchImage[2];
            comic.requestPage( url, comic.Image );
        } else {
            comic.error();
        }

        const expPrev = new RegExp( "<a href=\"" + mainPage + "(\\d{4}/\\d{2}/\\d{2}/)[^\"]+\"><img src=\"http://goodtimescomics.com/wp-content/stuff/previousbutton.jpg\" />" );
        const matchPrev = expPrev.exec( data );
        if ( matchPrev != null ) {
            comic.previousIdentifier = date.fromString( matchPrev[1], "yyyy/MM/dd/" );
        }

        const expNext = new RegExp( "<a href=\"" + mainPage + "(\\d{4}/\\d{2}/\\d{2}/)[^\"]+\"><img src=\"http://goodtimescomics.com/wp-content/stuff/nextbutton.jpg\" />" );
        const matchNext = expNext.exec( data );
        if ( matchNext != null ) {
            comic.nextIdentifier = date.fromString( matchNext[1], "yyyy/MM/dd/" );
        }
    }
}
