/***************************************************************************
 *   Copyright (C) 2018 Matthias Fuchs <mat69@gmx.net>                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

function init()
{
    comic.comicAuthor = "Tracy J. Butler";
    comic.firstIdentifier = 1;

    var url = "https://www.lackadaisycats.com/comic.php";
    if (comic.identifierSpecified) {
        url += "?comicid=" + comic.identifier;
    }
    comic.requestPage(url, comic.Page);
}

function pageRetrieved(id, data)
{
    if (id == comic.Page) {
        //find the most recent strip
        var re = new RegExp("<option value=\"(\\d+)\"[^>]*>Lackadaisy ([^<]+)</option></select>");
        var match = re.exec(data);
        if (match != null) {
            comic.lastIdentifier = match[1];
            print("Last identifier: " + comic.lastIdentifier);
        } else {
            print("Could not find the most recent strip.");
            comic.error();
            return;
        }

        comic.websiteUrl = "https://www.lackadaisycats.com/comic.php?=" + comic.identifier;

        //find the title
        re = new RegExp("<title>Lackadaisy :: Lackadaisy ([^<]+)</title>");
        match = re.exec(data);
        if (match != null) {
            comic.title = match[1];
        }

        //find the store
        re = new RegExp("id=\"navstore\"><a href=\"([^\"]+)\"");
        match = re.exec(data);
        if (match != null) {
            comic.shopUrl = match[1];
        }

        //in at least one occation there is one number not served
        //find the next strip
        re = new RegExp("=(\\d+)\">Next");
        match = re.exec(data);
        if (match != null) {
            comic.nextIdentifier = match[1];
        }

        //find the next strip
        re = new RegExp("=(\\d+)\">Previous");
        match = re.exec(data);
        if (match != null) {
            comic.previousIdentifier = match[1];
        }

        //find the comic image
        re = new RegExp("src=\"(comic/[^\"]+)\"");
        match = re.exec(data);
        if (match != null) {
            comic.requestPage("https://www.lackadaisycats.com/" + match[1], comic.Image);
        } else {
            print(data);
            print("Could not find comic image: " + comic.identifier);
            comic.error();
            return;
        }
    }
}

