/***************************************************************************
 *   Copyright (C) 2008 Matthias Fuchs <mat69@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .
 ***************************************************************************/

const dateFormat = 'yyyy/MM/dd';

function init()
{
    comic.comicAuthor = 'Mike Krahulik, Jerry Holkins';
    comic.firstIdentifier = date.fromString('1998/11/18', dateFormat);
    comic.websiteUrl = 'https://www.penny-arcade.com/comic/';
    comic.shopUrl = 'https://store.penny-arcade.com/';

    comic.requestPage(comic.websiteUrl, comic.User);
}

function pageRetrieved(id, data)
{
    //find lastIdentifier
    if (id == comic.User) {
        var rx = new RegExp('<meta property="og:url" content="[^"]+(\\d{4}/\\d{2}/\\d{2})');
        var match = rx.exec(data);
        if (match != null) {
            comic.lastIdentifier = date.fromString(match[1], dateFormat);
            comic.websiteUrl += comic.identifier.toString(dateFormat);
            comic.requestPage(comic.websiteUrl, comic.Page);
        } else {
            print('Could not find last identifier.');
            comic.error();
            return;
        }
    }

    //find comic strip and next/previous identifier
    if (id == comic.Page) {
        var rx = new RegExp('<a class="btn btnNext" href="[^"]+(\\d{4}/\\d{2}/\\d{2})');
        var match = rx.exec(data);
        if (match != null) {
            comic.nextIdentifier = date.fromString(match[1], dateFormat);
        }

        rx = new RegExp('<a class="btn btnPrev" href="[^"]+(\\d{4}/\\d{2}/\\d{2})');
        match = rx.exec(data);
        if (match != null) {
            comic.previousIdentifier = date.fromString(match[1], dateFormat);
        }

        rx = new RegExp('<div id="comicFrame">.*<img src="([^"]+)" alt="([^"]*)"');
        match = rx.exec(data);
        if (match != null) {
            comic.title = match[2];
            comic.requestPage(match[1], comic.Image);
        } else {
            comic.error();
            print('Could not find comic image.');
            return;
        }
    }
}
