/***************************************************************************
 *   Copyright (C) 2008 Matthias Fuchs <mat69@gmx.net>                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

function init()
{
    comic.comicAuthor = "Nicholas Gurewitch";
    comic.websiteUrl = "http://pbfcomics.com/";

    comic.requestPage( comic.websiteUrl, comic.User );
}

function pageRetrieved(id, data)
{
    //find the lastIdentifier, title and the websiteUrl
    if ( id == comic.User ) {
        const expLast = new RegExp( "<br><br>\\s+<a href=\"\\?cid=[^\"]+\">[^<]+</a> <a name=\"(\\d+)\">" );
        const matchLast = expLast.exec( data );
        if ( matchLast != null ) {
            comic.lastIdentifier = matchLast[1];

            const expWebsite = new RegExp( "<a href=\"\\?cid=([^\"]+)\">([^<]+)</a> <a name=\"" + comic.identifier + "\">" );
            const matchWebsite = expWebsite.exec( data );
            if ( matchWebsite != null ) {
                comic.websiteUrl += "?cid=" + matchWebsite[1];
                comic.title = matchWebsite[2];
                comic.requestPage( comic.websiteUrl, comic.Page );
            } else {
                comic.error();
            }
        } else {
            comic.error();
        }
    }
    if ( id == comic.Page ) {
        const expImage = new RegExp( "<img id=\"topimg\" src=\"([^\"]+)\"" );
        const matchImage = expImage.exec( data );
        if ( matchImage != null ) {
            var url = "http://pbfcomics.com/" + matchImage[1];
            comic.requestPage( url, comic.Image );
        } else {
            comic.error();
        }
    }
}
