/***************************************************************************
 *   Copyright (C) 2018 Matthias Fuchs <mat69@gmx.net>                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

function init()
{
    comic.comicAuthor = "Jason Brubaker";
    comic.firstIdentifier = "remind-cover-maybe";
    comic.lastIdentifier = "thank-you3";

    comic.websiteUrl = "http://www.remindblog.com/custom/" + comic.identifier;
    comic.requestPage(comic.websiteUrl, comic.Page);
}

function pageRetrieved(id, data)
{
    //find the last strip
    if (id == comic.User) {
        var re = new RegExp("href=\"http://www.remindblog.com/(\\d{4}/\\d{2}/\\d{2}[^\"]*)\">Last");
        var match = re.exec(data);
        if (match != null) {
            comic.lastIdentifier = match[1];
            comic.websiteUrl += comic.identifier;
            comic.requestPage(comic.websiteUrl, comic.Page);
        } else {
            print("Could not find last comic.");
            comic.error();
        }
        return;
    }

    if (id == comic.Page) {
        var re = new RegExp('rel="next" href="http://www.remindblog.com/custom/([^/]+)/"');
        var match = re.exec(data);
        if (match != null) {
            comic.nextIdentifier = match[1];
        }

        re = new RegExp('rel="prev" href="http://www.remindblog.com/custom/([^/]+)/"');
        match = re.exec(data);
        if (match != null) {
            comic.previousIdentifier = match[1];
        }

        var re = new RegExp('"og:image" content="([^"]+\\.jpg)');
        var match = re.exec(data);
        if (match != null) {
            comic.requestPage(match[1], comic.Image);
        } else {
            print(data);
            comic.error();
            return;
        }
    }
}
