/*
 *   Copyright (C) 2009 Mathias Panzenböck <grosser.meister.morti@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

const mainPage = 'http://www.savagechickens.com/';

function init() {
	comic.comicAuthor     = 'Doug Savage';
	comic.firstIdentifier = '2005/01/welcome_110904589107880022.html';
	comic.shopUrl         = 'http://www.cafepress.com/savagechickens/';
	
	if (comic.identifierSpecified) {
		comic.requestPage(mainPage + comic.identifier, comic.Page);
	}
	else {
		comic.requestPage('http://www.savagechickens.com/feed/rss', comic.User);
	}
}

function pageRetrieved(id, data) {
	if (id == comic.User) {
		var re = /<link>(http:\/\/www\.savagechickens\.com\/([^<]*\.html))<\/link>/;
		var match = re.exec(data);

		if (match != null) {
			comic.lastIdentifier = comic.identifier = match[2];
			comic.requestPage(match[1], comic.Page);
		}
		else {
			print('*** could not parse newest comic');
			comic.error();
		}
	}
	else if (id == comic.Page) {
		comic.websiteUrl = mainPage + comic.identifier;

		// get image url
		var re = /<img src="(http:\/\/www\.savagechickens\.com\/images\/[^\/]*\.\w+)"/;
		var match = re.exec(data);

		if (match == null) {
			print("*** could not parse image url of " + comic.identifier);
			comic.error();
			return;
		}

		comic.requestPage(match[1], comic.Image);

		// get title
		re = /<h1>([^<]*)<\/h1>/;
		match = re.exec(data);
		if (match != null) {
			comic.title = match[1];
		}

		// get description
		re = /<img src="http:\/\/www\.savagechickens\.com\/images\/[^\/]*\.\w+"/;
		var i = data.search(re);
		if (i != -1) {
			var descr = data.substring(i);
			i = descr.search('\n');
			if (i != -1) {
				descr = descr.substring(i);
				i = descr.search('<div class="postmeta">');
				if (i != -1) {
					descr = descr.substring(0, i);
				}
				descr = /^\s*(.*\S|)\s*$/.exec(descr)[1];

				if (descr.length != 0) {
					comic.additionalText = descr;
				}
			}
		}

		// get prev link
		re = /&laquo; <a href="http:\/\/www\.savagechickens\.com\/([^"]*)">Previous<\/a>/;
		match = re.exec(data);
		if (match != null) {
			comic.previousIdentifier = match[1];
		}

		// get next link
		re = /<a href="http:\/\/www\.savagechickens\.com\/([^"]*)">Next<\/a> &raquo;/;
		match = re.exec(data);
		if (match != null) {
			comic.nextIdentifier = match[1];
		}
	}
}
