/***************************************************************************
 *   Copyright (C) 2008-2010 Matthias Fuchs <mat69@gmx.net>                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

function init()
{
    comic.comicAuthor = "Oskar Pannier, Marvin Clifford";
    comic.firstIdentifier = "rote-staffel/wie-alles-begann/"
    comic.shopUrl = "http://www.sfshop.de/";
    comic.websiteUrl = "http://www.shakesandfidget.com/comics/";

    if (comic.identifierSpecified) {
        comic.websiteUrl += comic.identifier;
        comic.requestPage(comic.websiteUrl, comic.Page);
    } else {
        comic.requestPage(comic.websiteUrl, comic.User);
    }
}

function findMostRecent(data)
{
    var pattern = "Neueste Folge</h2>\n*\\s*<a href=\"http://www.shakesandfidget.com/comics/([^\"]+)\""
    var re = new RegExp(pattern);
    var match = re.exec(data);

    if (match != null) {
        comic.lastIdentifier = match[1];
        comic.websiteUrl += comic.identifier;
        return true;
    } else {
        comic.error();
        return false;
    }
}

function pageRetrieved(id, data)
{
    //find the most recent strip
    if (id == comic.User) {
        if (findMostRecent(data)) {
            comic.requestPage(comic.websiteUrl, comic.Page);
        }
    }
    //find the comic
    if (id == comic.Page) {
        if (!findMostRecent(data)) {
            return;
        }

        var pattern = "comicpane\"><a  href=\"[^\"]*\" title=\"([^\"]+)\"><img src=\"([^\"]+)\"";
        var re = new RegExp(pattern);
        var match = re.exec(data);
        
        var url;
        if (match != null) {
            url = match[2];
            comic.title = match[1];
        } else {
            comic.error();
            return;
        }

        pattern = "nav-previous\"><a href=\"http://www.shakesandfidget.com/comics/([^\"]+)\""
        re = new RegExp(pattern);
        match = re.exec(data);
        if (match != null) {
            comic.previousIdentifier = match[1];
        }

        pattern = "nav-next\"><a href=\"http://www.shakesandfidget.com/comics/([^\"]+)\""
        re = new RegExp(pattern);
        match = re.exec(data);
        if (match != null) {
            comic.nextIdentifier = match[1];
        }

        comic.requestPage(url, comic.Image);
    }
}
