/*
*   Copyright (C) 2008-2017 Matthias Fuchs <mat69@gmx.net>
*   Copyright (C) 2019 Hans-Peter Jansen <hpj@urpla.net>
*
*   This program is free software; you can redistribute it and/or modify
*   it under the terms of the GNU Library General Public License as
*   published by the Free Software Foundation; either version 2, or
*   (at your option) any later version.
*
*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details
*
*   You should have received a copy of the GNU Library General Public
*   License along with this program; if not, write to the
*   Free Software Foundation, Inc.,
*   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

function init()
{
    comic.comicAuthor = "Ralph Ruthe";
    comic.shopUrl = "http://www.kiddinx-shop.de/ruthe";
    comic.websiteUrl = "https://ruthe.de";
    comic.firstIdentifier = 1;

    comic.requestPage(comic.websiteUrl, comic.User);
}

function pageRetrieved(id, data)
{
    var url = comic.websiteUrl;

    //find the most recent strip on front page
    if (id == comic.User) {
        var re = new RegExp('id="link_archive" href="/archiv/(\\d+)/datum/asc/"');
        var match = re.exec(data);
        if (match != null) {
            comic.lastIdentifier = match[1];
            url += "/cartoon/" + comic.identifier + "/datum/asc/";
	    print("Fetch page " + url);
            comic.requestPage(url, comic.Page);
        } else {
            print("Failed to fetch most recent strip from " + comic.websiteUrl);
            comic.error();
        }
    }

    else if (id == comic.Page) {
        // get previous id
        var re = new RegExp('id="n_prev" href="/cartoon/(\\d+)/datum/asc/"');
        var match = re.exec(data);
        if (match != null && comic.identifier != 1) {
            comic.previousIdentifier = match[1];
        } else {
            print("No previous strip.");
        }

        // get next id
        var re = new RegExp('id="n_next" href="/cartoon/(\\d+)/datum/asc/"');
        var match = re.exec(data);
        if (match != null && match[1] != "1") {
            comic.nextIdentifier = match[1];
        } else {
            print("No next strip.");
        }

        // no comic.title
        comic.additionalText = comic.identifier;

	// fetch strip
        var re = new RegExp('<img src="(/cartoons/strip_\\d+\.jpg)"');
        var match = re.exec(data);
        if (match != null) {
            url += match[1];
	    print("Fetch image " + url);
	    comic.requestPage(url, comic.Image);
        } else {
            print("Failed to locate strip image link.");
            comic.error();
        }
    }
}
