/***************************************************************************
 *   Copyright (C) 2018 Matthias Fuchs <mat69@gmx.net>                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA .        *
 ***************************************************************************/

const homepage = "https://www.meekcomic.com";

function init()
{
    comic.comicAuthor = "Der-Shing Helmer";
    comic.firstIdentifier = "chapter-1-cover";
    comic.shopUrl = "https://www.meekcomic.com/store/";
    comic.websiteUrl = homepage;

    if (comic.identifierSpecified) {
        comic.websiteUrl = homepage + "/comic/" + comic.identifier;
        comic.requestPage(comic.websiteUrl, comic.Page);
    } else {
        comic.requestPage(comic.websiteUrl, comic.User);
    }
}

function pageRetrieved(id, data)
{
    //find most recent strip
    if (id == comic.User) {
        var re = new RegExp('entry-title"><a href="https://www.meekcomic.com/comic/([^/]+)/');
        var match = re.exec(data);
        if (match != null) {
            comic.lastIdentifier = match[1];
            comic.websiteUrl = homepage + "/comic/" + comic.identifier;
            comic.requestPage(comic.websiteUrl, comic.Page);
            return;
        } else {
            print("Could not find most recent comic.");
            comic.error();
            return;
        }
    }

    if (id == comic.Page) {
        //find next
        re = new RegExp('<a href="https://www.meekcomic.com/comic/([^/]+)/" class="[^"]+comic-nav-next');
        match = re.exec(data);
        if (match != null) {
            comic.nextIdentifier = match[1];
        }

        //find previous
        re = new RegExp('<a href="https://www.meekcomic.com/comic/([^/]+)/" class="[^"]+comic-nav-previous');
        match = re.exec(data);
        if (match != null) {
            comic.previousIdentifier = match[1];
        }

        //find the comic image
        re = new RegExp('og:image" content="([^"]+)"');
        match = re.exec(data);
        if (match != null) {
            comic.requestPage(match[1], comic.Image);
        } else {
            print("Failed in finding the comic image.");
            comic.error();
            return;
        }
    }
}
