/*
 *   Copyright (C) 2008 Heiko Jansen <heiko_jansen@web.de>
 *   Copyright (C) 2019 Matthias Fuchs <mat69@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

var website = "http://www.unshelved.com/";

function init()
{
    comic.comicAuthor = "Bill Barnes, Gene Ambaum";
    comic.shopUrl = website + "store";
    comic.firstIdentifier = "2002-2-16";
    comic.requestPage(website, comic.User);
}

function pageRetrieved(id, data)
{
    if (id == comic.User) {
        var re = new RegExp(website + "(\\d{4}-\\d+-\\d+)");
        var match = re.exec(data);
        if (match == null) {
            print("Could not find last identifier.");
            comic.error();
            return;
        }

        comic.lastIdentifier = date.fromString(match[1], "yyyy-M-d");
        var url = website + comic.identifier.toString("yyyy-M-d");
        comic.requestPage(url, comic.Page)
    } else if (id == comic.Page) {
        var re = new RegExp("(http://get.unshelved.com/strips/\\d+[^\"]+)");
        var match = re.exec(data);
        if (match != null) {
            comic.requestPage(match[1], comic.Image);
        } else {
            print("Could not find comic image.");
            comic.error();
            return;
        }
    }
}
