/*
 *   Copyright (C) 2009 Mathias Panzenböck <grosser.meister.morti@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

const GetLast     = comic.User;
const mainPage    = 'http://warrior-u.com/';
const comicPrefix = 'http://warrior-u.com/?p=';

function init() {
	comic.comicAuthor     = 'Aisha Thani';
	comic.firstIdentifier = '7';
	comic.shopUrl         = 'http://hot-choc.deviantart.com/prints/';

	if (comic.identifierSpecified) {
		comic.requestPage(comicPrefix + comic.identifier, comic.Page);
	}
	else {
		comic.requestPage(mainPage, GetLast);
	}
}

function pageRetrieved(id, data) {
	if (id == comic.Image) {
		return;
	}

	var comicId;
	var re = /<h2 class="post-title"><a href="http:\/\/warrior-u.com\/\?p=(\d+)">(.*)<\/a><\/h2>/;
	var match = re.exec(data);
	if (match !== null) {
		comic.lastIdentifier = comic.identifier = comicId = match[1];
		comic.title = match[2];
	}
	else {
		print('*** error parsing last comic');
		comic.error();
		return;
	}

	comic.websiteUrl = comicPrefix + comicId;
	
	re = /<div id="comic-1" class="comicpane"><a +href="[^"]*" title="[^"]*"><img src="([^"]*)"/;
	match = re.exec(data);
	if (match !== null) {
		comic.requestPage(match[1], comic.Image);
	}
	else {
		print('*** error parsing image location');
		comic.error();
		return;
	}
	
	// find previous link
	re = /<a href="http:\/\/warrior-u.com\/\?p=(\d+)" class="navi navi-prev" title="Previous">Previous<\/a>/;
	match = re.exec(data);
	if (match !== null) {
		comic.previousIdentifier = match[1];
	}
	
	// find next link
	re = /<a href="http:\/\/warrior-u.com\/\?p=(\d+)" class="navi navi-next" title="Next">Next<\/a>/;
	match = re.exec(data);
	if (match !== null) {
		comic.nextIdentifier = match[1];
	}
}
