/*
 *   Copyright (C) 2009 Andrey 'Gildor' Mischenko <kde@gildor.ru>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Library General Public License version 2 as
 *   published by the Free Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details
 *
 *   You should have received a copy of the GNU Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.`
 */

function init()
{
    comic.comicAuthor = "Randall Munroe";
    comic.websiteUrl = "http://xkcd.ru/";
    
    if (comic.identifier) {
        //If we have current page
      
        //Currently first ID in russian XKCD
        comic.firstIdentifier = 2;
        comic.websiteUrl += comic.identifier + "/";
        comic.requestPage(comic.websiteUrl, comic.Page);
    } else {
        //get last ID
        comic.firstIdentifier = 2;
        comic.requestPage(comic.websiteUrl + comic.firstIdentifier + "/", comic.User);
    }
}

function pageRetrieved(id, data)
{
    if (id == comic.User) {
      //get last ID
      
      var re = new RegExp("href=\"/(\\d+)/\">&gt;\\|");
      var match = re.exec(data);
      if (match != null) {
          comic.lastIdentifier = match[1];
          comic.identifier = comic.lastIdentifier;
          comic.websiteUrl += comic.identifier + "/";
          comic.requestPage(comic.websiteUrl, comic.Page);
      } else {
          comic.error();
      }
    }
    
    if (id == comic.Page) {
      //Next ID
      var re = new RegExp("href=\"/(\\d+)/\">....&gt;");
      var match = re.exec(data);
      if ( match != null ) {
          comic.nextIdentifier = match[1];
      }

      //Prev ID
      var re = new RegExp("href=\"/(\\d+)/\">&lt;....");
      var match = re.exec(data);
      if ( match != null ) {
          comic.previousIdentifier = match[1];
      }

      
      //find the tooltip and the strip title of the comic
      re = new RegExp("src=\"http://xkcd.ru/i/[^\"]+\" alt=\"([^\"]+)\"");
      match = re.exec(data);
      if (match != null) {
          comic.title = match[1];
      }
      
      re = new RegExp("comics_text\">([^<]+)");
      match = re.exec(data);
      if (match != null) {
          comic.additionalText = comic.title + "<br>-------<br>" + match[1];
      }
      
      //Current Image
      var re = new RegExp("src=\"(http://xkcd.ru/i/[^\"]+)\"");
      var match = re.exec(data);
      if (match != null) {
          comic.requestPage(match[1], comic.Image);
      } else {
          comic.error();
          return;
      }
    }
}
