/*
 *   yodablog plugin for comic plasma widget
 *   Copyright (C) 2011 Mathieu Guilbaud <mathieu@guim.info>
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

const imgSrc = "http://www.yodablog.net/wp-content/uploads/";

function init() {
	comic.comicAuthor = "Yod@";
	comic.firstIdentifier = "1";
	comic.websiteUrl = "http://www.yodablog.net/";
	comic.shopUrl = "http://www.yodablog.net";
	
	if ( comic.identifierSpecified ) {
		comic.requestPage(comic.websiteUrl+"?p="+comic.identifier, comic.Page);
	} else {
		// find current
		comic.requestPage(comic.websiteUrl, comic.User);
	}
}

function pageRetrieved(id, data) {
	if (id == comic.User) {
		var re = new RegExp("<div id=\"main\">[^<]*<div class=\"post\" id=\"post-(\\d+)\">");
		var match = re.exec(data);
		if (match != null) {
			comic.identifier = match[1];
			comic.lastIdentifier = match[1];
			comic.requestPage(comic.websiteUrl+"?p="+comic.identifier, comic.Page);
		}
	}
	if (id == comic.Page) {
		var re = new RegExp("<div class=\"post\" id=\"post-\\d+\">[^<]*<h2>([^<]+)</h2>");
		var match = re.exec(data);
		if (match != null) {
			comic.title = match[1];
			comic.additionalText = match[1];
		}
		
		re = new RegExp("<span class=\"prev\"><a href=\"http://www.yodablog.net/\\?p=(\\d+)\">");
		match = re.exec(data);
		if (match != null) {
			comic.nextIdentifier = match[1];
		}
		
		re = new RegExp("<span class=\"next\"><a href=\"http://www.yodablog.net/\\?p=(\\d+)\">");
		match = re.exec(data);
		if (match != null) {
			comic.previousIdentifier = match[1];
		}
		
		re = new RegExp("<div class=\"content\">[^<]*<p><img class=\"[^\"]*\" title=\"[^\"]*\" src=\"([^\"]+)\" alt=");
		match = re.exec(data);
		if (match != null) {
			comic.requestPage(match[1], comic.Image);
		}
		else {
			comic.error();
		}
	}
}